//
//
// C++ Implementation: $MODULE$
//
// Description:
//
//
// Author: ian reinhart geiser <geiseri@yahoo.com>, (C) 2003
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "stationdatabase.h"
#include <qstringlist.h>
#include <qfile.h>
#include <kstandarddirs.h>
#include <klocale.h>

class StationInfo
{
	public:
		QString cityName;
		QString country;
		QString longitude;
		QString latitude;
		StationInfo () : cityName( QString::null ),
				country( QString::null ),
				longitude( QString::null ),
				latitude( QString::null )
		{
			;
		}
};

StationDatabase::StationDatabase( QObject *parent, const char *name )
		: QObject ( parent, name )
{
	theDB.clear();
}


StationDatabase::~StationDatabase()
{}

/*!
    \fn StationDatabase::loadDatabase()
 */
bool StationDatabase::loadDatabase()
{
	QString path = KGlobal::dirs()->findResource("data", "kweatherservice/stations.dat");
	QFile file( path );
	if ( file.open( IO_ReadOnly ) )
	{
		QTextStream stream( &file );
		QString line;
		int i = 1;
		while ( !stream.eof() )
		{
			line = stream.readLine(); // line of text excluding '\n'
			QStringList data = QStringList::split( ";", line, true );
			StationInfo station;
			station.cityName = data[ 3 ];
			station.country = data[ 5 ];
			station.longitude = data[ 7 ];
			station.latitude = data[ 8 ];

			theDB.insert( data[ 0 ], station );
		}
		file.close();
		return true;
	}
	else
		return false;
}
/*!
    \fn StationDatabase::stationNameFromID(const QString& id)
 */
QString StationDatabase::stationNameFromID( const QString & stationID )
{

	return theDB[ stationID ].cityName;

}

/*!
    \fn StationDatabase::stationLongitudeFromID( const QString &stationID)
 */
QString StationDatabase::stationLongitudeFromID( const QString & stationID )
{
	return theDB[ stationID ].longitude;

}

/*!
    \fn StationDatabase::stationLatitudeFromID(const QString &stationID)
 */
QString StationDatabase::stationLatitudeFromID( const QString & stationID )
{
	return theDB[ stationID ].latitude;

}

/*!
    \fn StationDatabase::stationCountryFromID( const QString &stationID)
 */
QString StationDatabase::stationCountryFromID( const QString &stationID )
{
	return theDB[ stationID ].country;
}


#include "stationdatabase.moc"




